<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Hello Types</title>

		<link rel="stylesheet" href="css/reveal.css">
        <link rel="stylesheet" href="css/theme/sky.css">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/zenburn.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appnendChild( link );
		</script>
	</head>
	<body>
		<div class="reveal">
			<div class="slides">



				<section>
                    <h1>Hello Types</h1>
                    <!-- <img src="images/idea.jpeg"/> -->
                    <img src="images/logo.jpeg" height="250em"/>
                    <br/>
                    <a href="https://pres-py-types-tutorial-dot-prelude-za.appspot.com">https://pres-py-types-tutorial-dot-prelude-za.appspot.com</a>

				</section>

				<section>
					<h2>Ice breaker</h2>
					<img src="images/fat-penguine.jpeg" height="350em"/><br/>

                    <!--
                        - professional/hobbiest/student
                        - tools/libraries/frameworks that you are working with
                        - any experience with statically typed languages?
                    -->

				</section>

                <section>
                    <h2><a href="http://sheenacv.prelude.co.za/" target="_blank">Me :)</a></h2>
                    <ul>
                        <li>Been coding in Python for 8 years</li>
                        <li>Thinks gradual typing is a bloody good idea</li>
                        <li><a href="https://www.codementor.io/i/kvo1e6ewh" target="_blank">CodementorX</a></li>
                        <li>

                        <a href="mailto:sheena@prelude.co.za?Subject=types%20tut%20response">sheena@prelude.co.za</a>
                        </li>
                    </li>
                        <li><a href="https://twitter.com/preludeza" target="_blank">Twitter: @preludeza</a></li>
                    </ul>
                </section>

                <section>
                    <h2>Contents</h2>
                    <ul>
                        <li class="fragment">Setup</li>
                        <li class="fragment">Why type? Why not?</li>
                        <li class="fragment">MyPy and Typing</li>
                        <li class="fragment">Type hint notations</li>
                        <li class="fragment">Advanced type hints</li>
                        <li class="fragment">Where to from here?</li>
                    </ul>
                </section>

                <section>
                <section>
                    <h2>Setup</h2> <!-- ok -->
                </section>

                <section>
                    <h3>Prerequisites</h3>
                    <div class="fragment">
                    Python 3.6+
                    <pre><code class="hljs" data-trim contenteditable>
python3 -m pip install mypy
python3 -m pip install typingextensions
                    </code></pre>
                </div>
                    <div class="fragment">

                    Python 2.7
                    <pre><code class="hljs" data-trim contenteditable>
python -m pip install typing
                    </code></pre>
</div>
</section>
                <section>
                    <h3>Links</h3>
                    <ul>
                        <li><a href="https://mypy.readthedocs.io/en/latest/cheat_sheet.html" target="_blank">Py2 cheatsheet: https://mypy.readthedocs.io/en/latest/cheat_sheet.htmls</a></li>
                        <li><a href="https://mypy.readthedocs.io/en/latest/cheat_sheet_py3.html" target="_blank">Py3 cheatsheet: https://mypy.readthedocs.io/en/latest/cheat_sheet_py3.html</a></li>
                        <li><a href="https://gitlab.com/sheena.oconnell/presentation-hello-python-typechecking/tree/master/excercises" target="_blank">Excercises directory: https://gitlab.com/sheena.oconnell/presentation-hello-python-typechecking/tree/master/excercises</a></li>
                    </ul>
                </section>
            </section>

                <section>
                    <h2>Why type? Why not?</h2> <!-- ok -->

                    <section>
                    <img class="fragment" src="images/be like sally.png">
                    </section>
                    <section>

                    <ul>
                        <li>removes many runtime bugs</li>
                        <li class="fragment">Explicit is better than implicit</li>
                        <li class="fragment">Self documenting code</li>
                        <li class="fragment">Dont get out of date like docstrings</li>
                        <li class="fragment">Gradual typing, not static typing</li>
                        <li class="fragment">Slows down the coding process?? <span class="fragment">Just like unit tests and sensable naming conventions, right?</span></li>
                    </ul>
                    </section>

                </section>

                <section>

                    <section>
                    <h2><a href="http://mypy-lang.org/" target="_blank" >Mypy</a> and <a href="https://docs.python.org/3/library/typing.html" target="_blank">typing</a></h2> <!-- ok -->

                    <ul>
                        <li class="fragment">mypy is considered the "reference implementation" for python typing </li>
                        <li class="fragment">a lot of what is now standard practice is borrowed from mypy</li>
                        <li class="fragment">static analyser (think linter)</li>
                        <li class="fragment">command line or integrated into editor</li>
                        <li class="fragment">MyPy Runs on Python 3.4+ </li>
                        <li class="fragment">Type annotations are a part of Python3.5+ </li>
                        <li class="fragment">Python will remain a dynamically typed language!</li>
                    </ul>
                    </section>

                    <section>
                    <h3>mypy alternatives</h3>

                    <ul>
                        <li><a href="https://pyre-check.org/" target="_blank">Pyre</a></li>
                        <li><a href="https://opensource.google.com/projects/pytype" target="_blank">PyType</a></li>
                    </ul>

                    </section>
                </section>

                <section>
                    <h2>Type hint notations</h2> <!-- ok -->
                    <ul>
                        <li class="fragment">Comments</li>
                        <li class="fragment">Annotations</li>
                        <li class="fragment">Stub Files</li>
                    </ul>
                </section>

                <section>
                    <section>
                        <h3>Comments</h3>
                        <ul>
                            <li class="fragment"> If your code needs to support < Python3.5 </li>
                            <li class="fragment"> Standard python syntax checker wont complain if you get something wrong</li>
                        </ul>
                    </section>

                    <section>
                        Example
                    <pre><code class="hljs" data-trim contenteditable>

from typing import List

def hello(): # type: () -> None
    print 'hello'

class Example:
    def method(self, lst, opt=0, *args, **kwargs):
        # type: (List[str], int, *str, **bool) -> int
        """Docstring comes after type comment.
        dont give a type to self
        note * and **
        """
        etc

    @classmethod
    def cls_method(cls,lst)
        # type: (List[str]) -> int
        """dont give a type to cls"""

i = 1          # type: int
ex = Example() # type: Example


                    </code></pre>
                    </section>

                    <section>
                        Example
                    <pre><code class="hljs" data-trim contenteditable>

from typing import List

class Example:
    def method(self,
               lst,     # type: List[str]
               opt=0,   # type: int
               *args,   # type: str
               **kwargs # type: bool
               ):
        # type: (...) -> int
        """
        note LACK of * and **
        """
        etc

                    </code></pre>
                    </section>

<section>
    Types can be...
    <ul>
        <li class="fragment">basic Python types (`int`, `str`, etc)</li>
        <li class="fragment">Imported from the `typing` module</li>
        <li class="fragment">None</li>
        <li class="fragment">classes</li>
        <li class="fragment">subscriptable (`List[str]`)</li>
    </ul>

</section>


<section>
    Excercise<br/>
    Add type comments to <a href="https://gitlab.com/sheena.oconnell/presentation-hello-python-typechecking/blob/master/excercises/caesar.py" target="_blank">caesar.py</a>
    <br/>

    <pre><code class="hljs" data-trim contenteditable>
        mypy --py2 program.py
        # or
        mypy program.py
    </code></pre>

</section>


<section>
Answer
    <pre><code class="hljs" data-trim contenteditable>
import string
from typing import List

characters = string.ascii_letters + string.digits
count = len(characters)


def encode(s, n):
    # type: (str, int) -> str
    encoded = [_encode_char(char, n) for char in s]  # type: List[str]
    return ''.join(encoded)


def decode(s, n):
    # type: (str, int) -> str
    decoded = [_decode_char(char, n) for char in s]  # type: List[str]
    return ''.join(decoded)


def _encode_char(char, n):
    # type: (str, int) -> str
    if char not in characters:
        return char
    original_index = characters.index(char)  # type: int
    new_index = original_index + n           # type: int
    fixed_index = new_index % count          # type: int
    return characters[fixed_index]


def _decode_char(char, n):
    # type: (str, int) -> str
    return _encode_char(char, -n)


def test_encode_char():
    # type: () -> None
    assert _encode_char('a', 1) == 'b'
    assert _encode_char('z', 1) == 'A'
    assert _encode_char('Z', 1) == '0'
    assert _encode_char('9', 1) == 'a'

    assert _encode_char('a', len(characters) + 1) == 'b'
    assert _encode_char('z', len(characters) + 1) == 'A'
    assert _encode_char('Z', len(characters) + 1) == '0'
    assert _encode_char('9', len(characters) + 1) == 'a'


def test_decode_char():
    # type: () -> None
    assert _decode_char('b', 1) == 'a'
    assert _decode_char('A', 1) == 'z'
    assert _decode_char('0', 1) == 'Z'
    assert _decode_char('a', 1) == '9'

    assert _decode_char('b', len(characters) + 1) == 'a'
    assert _decode_char('A', len(characters) + 1) == 'z'
    assert _decode_char('0', len(characters) + 1) == 'Z'
    assert _decode_char('a', len(characters) + 1) == '9'


def test_string_encode_decode():
    # type: () -> None
    assert encode('azZ9', 1) == 'bA0a'
    assert decode('bA0a', 1) == 'azZ9'
    s = "Th3 qu1ck br0wn f0x jump5 over the lazy dog, and away he goes!" # type: str
    assert decode(encode(s, 1), 1) == s
    assert decode(encode(s, 10), 10) == s
    assert decode(encode(s, 100), 100) == s


    </code></pre>
</section>

</section>


<section>

    <section>
        <h3>Annotations</h3>
        <ul>
            <li class="fragment">New Python syntax</li>
            <li class="fragment">Introduced in Python3.5</li>
            <li class="fragment">Standard python syntax checker will complain if you get something wrong</li>
        </ul>
    </section>



                    <section>
                        Example
                    <pre><code class="hljs" data-trim contenteditable>
from typing import List

def hello() -> None:
    print('hello')

class Example:
    def method(self, lst: List[str], opt: int=0, *args: str, **kwargs: bool) -> int:
        """dont give a type to self
        note * and **
        """
        etc
    @classmethod
    def cls_methodss(cls, lst: List[int]) -> int:
        """dont give a type to cls"""
        etc

</code></pre>
                    </section>

                                        <section>
                        Recent development<br/>

                        <a href="https://mypy.readthedocs.io/en/latest/python36.html" target="_blank">
                        New syntax added in Python 3.6!</a>


                    <pre><code class="hljs" data-trim contenteditable>

                        # < 3.6
                        foo = [] # type: List[str]

                        # >= 3.6
                        bar: List[str] = []

                    </code></pre>


                    </section>


                    <section>
                        Excercise <br/>
                        Add type annotations to <a href="https://gitlab.com/sheena.oconnell/presentation-hello-python-typechecking/blob/master/excercises/caesar.py" target="_blank">caesar.py</a>
    <br/>

    <pre><code class="hljs" data-trim contenteditable>
        mypy --py2 program.py
        # or
        mypy program.py
    </code></pre>

                    </section>

                    <section>
                        Answer
    <pre><code class="hljs" data-trim contenteditable>
import string
from typing import List

characters: str = string.ascii_letters + string.digits
count: int = len(characters)


def encode(s: str, n: int) -> str:
    encoded: List[str] = [_encode_char(char, n) for char in s]
    return ''.join(encoded)


def decode(s: str, n: int) -> str:
    decoded: List[str] = [_decode_char(char, n) for char in s]
    return ''.join(decoded)


def _encode_char(char: str, n: int) -> str:
    if char not in characters:
        return char
    original_index: int = characters.index(char)
    new_index: int = original_index + n
    fixed_index: int = new_index % count
    return characters[fixed_index]


def _decode_char(char: str, n: int) -> str:
    return _encode_char(char, -n)


def test_encode_char():
    assert _encode_char('a', 1) == 'b'
    assert _encode_char('z', 1) == 'A'
    assert _encode_char('Z', 1) == '0'
    assert _encode_char('9', 1) == 'a'

    assert _encode_char('a', len(characters) + 1) == 'b'
    assert _encode_char('z', len(characters) + 1) == 'A'
    assert _encode_char('Z', len(characters) + 1) == '0'
    assert _encode_char('9', len(characters) + 1) == 'a'


def test_decode_char():
    assert _decode_char('b', 1) == 'a'
    assert _decode_char('A', 1) == 'z'
    assert _decode_char('0', 1) == 'Z'
    assert _decode_char('a', 1) == '9'

    assert _decode_char('b', len(characters) + 1) == 'a'
    assert _decode_char('A', len(characters) + 1) == 'z'
    assert _decode_char('0', len(characters) + 1) == 'Z'
    assert _decode_char('a', len(characters) + 1) == '9'


def test_string_encode_decode():
    assert encode('azZ9', 1) == 'bA0a'
    assert decode('bA0a', 1) == 'azZ9'

    s = "Th3 qu1ck br0wn f0x jump5 over the lazy dog, and away he goes!"
    assert decode(encode(s, 1), 1) == s
    assert decode(encode(s, 10), 10) == s
    assert decode(encode(s, 100), 100) == s

    </code></pre>

                    </section>
</section>

<section>


                    <section>
                        <h3>Stub files</h3>
                        <ul>

                        <li class="fragment">a description of the public interface of the module without any implementations (think header file)</li>
                        <li class="fragment">pyi files</li>
                        <li class="fragment">can be alongside modules (csv.pyi and csv.py)
                        or in a seperate configurable location</li>
                        <li class="fragment">If both a .py and a .pyi file for the same module contain type hints, the .pyi file takes precedence</li>
                        <li class="fragment">allows adding type hints to source without touching the source</li>

                        </ul>

                    </section>

                    <section>
                        Mypy and <a href="https://github.com/python/typeshed" target="_blank">Typeshed</a><br/>
                        <ul>
                            <li class="fragment">Typeshed is a stub only package</li>
                            <li class="fragment">Contains stubs for std lib and select 3rd party packages</li>
                            <li class="fragment">MyPy package contains specific version of Typeshed</li>
                        </ul>
                    </section>

                    <section>
                        functions and variables
                    <pre><code class="hljs" data-trim contenteditable>
x: int

def afunc(code: str) -> int: ...
def anotherfunc(a: int, b: int = ...) -> int: ...
                    </code></pre>
                    </section>

<section>
                        Classes (jinja2 stub)


                    <pre><code class="hljs" data-trim contenteditable>
class ProcessedTraceback:
    exc_type = ...  # type: Any
    exc_value = ...  # type: Any
    frames = ...  # type: Any
    def __init__(self, exc_type, exc_value, frames) -> None: ...
    def render_as_text(self, limit: Optional[int] = ...) -> str: ...
</code></pre>


                    </section>


                    <section>

                    Jinja2 code
                    <pre><code class="hljs" data-trim contenteditable>


class ProcessedTraceback(object):
    """Holds a Jinja preprocessed traceback for printing or reraising."""

    def __init__(self, exc_type, exc_value, frames):
        assert frames, 'no frames for this traceback?'
        self.exc_type = exc_type
        self.exc_value = exc_value
        self.frames = frames

        # newly concatenate the frames (which are proxies)
        prev_tb = None
        for tb in self.frames:
            if prev_tb is not None:
                prev_tb.set_next(tb)
            prev_tb = tb
        prev_tb.set_next(None)

    def render_as_text(self, limit=None):
        """Return a string with the traceback."""
        lines = traceback.format_exception(self.exc_type, self.exc_value,
                                           self.frames[0], limit=limit)
        return ''.join(lines).rstrip()


                 </code></pre>

</section>


</section>






                    <section>
                        <h3>Choices Choices</h3>
                    <pre><code class="hljs" data-trim contenteditable>
if can_edit_source_code:
    if must_support_python_2:
        return use_comments
    elif must_support_less_than_py_36:
        return use_annotations_but_be_careful
    else:
        return use_annotations_to_your_hearts_content
else:
    return use_stubs
                    </code></pre>
                    </section>


            <section>
                <h2>Advanced type hints</h2> <!-- ok -->

                    <pre><code class="hljs" data-trim contenteditable>
from typing import TheBigGuns
                    </code></pre>

            </section>

            <section>

                <section>


                <h3>class Bee !!!</h3>
                All bees know at all times:
                <ul>
                    <li class="fragment">how many bees there are in the swarm</li>
                    <li class="fragment">the identities of all bees in the swarm</li>
                </ul>
                <br/>
                <span class="fragment">Also, bees collect and deposit pollen</span>

                </section>

                <section>
                    <img src="images/bees.gif" height="350em"/>
                </section>

                <section>

                    bees.py
                    <pre><code class="hljs" data-trim contenteditable>
class Bee:
    all_bees   = []
    bee_count  = 0
    has_pollen = False

    def __init__(self):
        self.all_bees.append(self)
        self.bee_count += 1

    def collect_pollen(self):
        self.has_pollen = True

    def deposit_pollen(self):
        self.has_pollen = False

def test_bee():
    bees = [Bee() for i in range(3)]
    for bee in bees:
        assert bee.all_bees == bees
        assert bee.bee_count == 3
                    </code></pre>
                    <a href="https://gitlab.com/sheena.oconnell/presentation-hello-python-typechecking/blob/master/excercises/bees.py" target="_blank">bees.py</a>
                </section>

                <section>
                   Failure!
<pre><code class="hljs" data-trim contenteditable>
====================================================== FAILURES ======================================================
______________________________________________________ test_bee ______________________________________________________

    def test_bee():
        bees = [Bee() for i in range(3)]
        for bee in bees:
            assert bee.all_bees == bees
>           assert bee.bee_count == 3
E           assert 1 == 3
E            +  where 1 = &ltbees0.Bee object at 0x7fe1ef395cf8>.bee_count

bees0.py:12: AssertionError
============================================== 1 failed in 0.10 seconds ==============================================
</code></pre>

                </section>


                <section>
                    add annotations...
<pre><code class="hljs" data-trim contenteditable>
from typing import List

class Bee:
    all_bees: List["Bee"] = []   ######
    etc

</code></pre>
                </section>

                <section>
                    add annotations...
<pre><code class="hljs" data-trim contenteditable>
from typing import List

class Bee:
    all_bees: List["Bee"] = []   ######
    bee_count: int        = 0
    has_pollen: bool      = False

    def __init__(self) -> None:
        self.all_bees.append(self)
        self.bee_count += 1

    def get_pollen(self) -> None:
        self.has_pollen = True

    def deposit_pollen(self) -> None:
        self.has_pollen = False

def test_bee():
    bees = [Bee() for i in range(3)]
    for bee in bees:
        assert bee.all_bees == bees
        assert bee.bee_count == 3

</code></pre>
                </section>




            <section>
                Introducing ClassVar
<pre><code class="hljs" data-trim contenteditable>
from typing import List, ClassVar

class Bee:
    all_bees: ClassVar[List["Bee"]] = []
    bee_count: ClassVar[int]        = 0
    has_pollen: bool                = False # No classvar

    def __init__(self) -> None:
        self.all_bees.append(self)
        self.bee_count += 1
        # error: Cannot assign to class variable "bee_count" via instance

    def get_pollen(self) -> None:
        self.has_pollen = True

    def deposit_pollen(self) -> None:
        self.has_pollen = False

def test_bee():
    bees = [Bee() for i in range(3)]
    for bee in bees:
        assert bee.all_bees == bees
        assert bee.bee_count == 3

</code></pre>

            </section>


            <section>

Final Version
<pre><code class="hljs" data-trim contenteditable>
from typing import List, ClassVar

class Bee:
    all_bees: ClassVar[List["Bee"]] = []
    bee_count: ClassVar[int]        = 0
    has_pollen: bool                = False # No classvar

    def __init__(self) -> None:
        self.all_bees.append(self) ####
        Bee.bee_count += 1         ####

    def get_pollen(self) -> None:
        self.has_pollen = True

    def deposit_pollen(self) -> None:
        self.has_pollen = False

def test_bee():
    bees = [Bee() for i in range(3)]
    for bee in bees:
        assert bee.all_bees == bees
        assert bee.bee_count == 3

</code></pre>

            </section>

            <section>
                Excercise

<pre><code class="hljs" data-trim contenteditable>
from typing import ClassVar

class Spam:
    egg: ClassVar[int] = 5
    cheese: str = "cheddar"

inst1 = Spam()
inst2 = Spam()

# what will be printed?
# are there any type errors?

print(inst1.egg)
print(inst1.cheese)

Spam.cheese = "gouda"
inst1.cheese = "parmasan"

print(inst1.cheese)
print(inst2.cheese)
print(Spam.cheese)

Spam.egg    = "poached"
inst1.egg   = 12
Spam.cheese = 12
</code></pre>
<a href="https://gitlab.com/sheena.oconnell/presentation-hello-python-typechecking/blob/master/excercises/classvar.py" target="_blank">classvar.py</a>

            </section>
 </section>


<section>
<section>
    <h3>Complex Types</h3>

    Sometimes a variable/parameter/return has multiple valid types...
</section>

<section>
    Introducing Union
<pre><code class="hljs" data-trim contenteditable>
from typing import Union

# union can have >= 1 types

a: Union[int,float,str] = 1
b: Union[int,float,str] = 2.22
c: Union[int,float,str] = 'hello'
d: Union[int,float,str] = None  # Error

# a union of unions is a union

Union[Union[int,str],Union[int,float],None]
# is equivalent to
Union[int,float,str,None]

# Unions can be used in function definitions just like normal types

def foo(a:Union[int,float]) -> Union[int,float,str,None]:
    etc

</code></pre>
</section>

<section>
    Introducing Dict
<pre><code class="hljs" data-trim contenteditable>
from typing import Dict

d1: Dict[KeyType,ValType] = {x:y}

d2: Dict[int,str] = {1:'a',2:'b'}
</code></pre>
</section>


<section>
    Introducing reveal_type
<pre><code class="hljs" data-trim contenteditable>
i = 0
s = '0'

reveal_type(i)
# mypy: error - Revealed type is 'builtins.int'
# python: NameError: name 'reveal_type' is not defined

reveal_type(s)
# mypy: error - Revealed type is 'builtins.str'
</code></pre>
</section>


<section>
    Excercise

<pre><code class="hljs" data-trim contenteditable>
from typing import Dict, Union

d1: Dict[int,str] = {1:'a',2:'b'}
d2 = {'a':1,'b':2}
d3 = {'a':1,'b':'hi there'}
d4 = {
    1 : 'a' , 2 : 222222 , 3 : 'c' , 5 : 12.3 , 6: 'f'
}

</code></pre>
<a href="https://gitlab.com/sheena.oconnell/presentation-hello-python-typechecking/blob/master/excercises/dict_and_union.py" target="_blank">dict_and_union.py</a>
</section>



<section>
    Excercise
<pre><code class="hljs" data-trim contenteditable>
database = {
    1 : 'a' , 2 : 222222 , 3 : 'c' , 5 : 12.3 , 6: 'f'
}

def get_by_id(id):
    if id in database:
        return database[id]
    return None

def print_it_n_times(s,n):
    print(s*n)

value = get_by_id(4)

print_it_n_times(value,4)

</code></pre>

<a href="https://gitlab.com/sheena.oconnell/presentation-hello-python-typechecking/blob/master/excercises/database.py" target="_blank">database.py</a>

</section>


<section>
    Run the code
<pre><code class="hljs" data-trim contenteditable>

Traceback (most recent call last):
  File "optional0.py", line 15, in &ltmodule>
    print_it_n_times(value,4)
  File "optional0.py", line 11, in print_it_n_times
    print(s*n)
TypeError: unsupported operand type(s) for *: 'NoneType' and 'int'

</code></pre>
</section>

<section>
    Add annotations...
<pre><code class="hljs" data-trim contenteditable>
from typing import List, Dict, Union

database: Dict[int,Union[str,int,float]] = {
    1 : 'a' , 2 : 222222 , 3 : 'c' , 5 : 12.3 , 6: 'f'
}

def get_by_id(id:int)-> Union[str,int,float,None]:
    if id in database:
        return database[id]
    return None

def print_it_n_times(s:Union[str,int,float],n:int) -> None:
    print(s*n)

value = get_by_id(4)

reveal_type(value)   ###
# Revealed type is 'Union[builtins.str, builtins.int, builtins.float, None]'

print_it_n_times(value,4)
# error: Argument 1 to "print_string_n_times" has incompatible type "Union[builtins.str, builtins.int, builtins.float, None]"; expected "str"

</code></pre>
</section>


<section>
    Fix the bug ...
<pre><code class="hljs" data-trim contenteditable>
from typing import List,Dict, Union

database: Dict[int,Union[str,int,float]] = {
    1 : 'a' , 2 : 222222 , 3 : 'c' , 5 : 12.3 , 6: 'f'
}

def get_by_id(id:int)-> Union[str,int,float,None]:
    if id in database:
        return database[id]
    return None

def print_it_n_times(s:Union[str,int,float],n:int) -> None:
    print(s*n)

value = get_by_id(4)

reveal_type(value)
# Revealed type is 'Union[builtins.str, builtins.int, builtins.float, None]'

if value is not None:
    reveal_type(value)
    # Revealed type is 'Union[builtins.str, builtins.float]'

    print_it_n_times(value,4)

</code></pre>
</section>


<section>
    Introducing aliases
<pre style="fragment"><code class="hljs" data-trim contenteditable>

from typing import List, Dict, Union

# make it DRY with an alias
DbValueType = Union[str,int,float]

database: Dict[int,DbValueType] = {
    1 : 'a' , 2 : 222222 , 3 : 'c' , 5 : 12.3 , 6: 'f'
}

</code></pre>
</section>

<section>
    Introducing aliases
<pre style="fragment"><code class="hljs" data-trim contenteditable>

from typing import List,Dict, Union

# make it DRY with an alias
DbValueType = Union[str,int,float]


database: Dict[int,DbValueType] = {
    1 : 'a' , 2 : 222222 , 3 : 'c' , 5 : 12.3 , 6: 'f'
}

def get_by_id(id:int)-> Union[DbValueType,None]:
    if id in database:
        return database[id]
    return None

def print_it_n_times(s:DbValueType,n:int) -> None:
    print(s*n)

value = get_by_id(4)

reveal_type(value)
# Revealed type is 'Union[builtins.str, builtins.int, builtins.float, None]'

if value is not None:
    reveal_type(value)
    # Revealed type is 'Union[builtins.str, builtins.float]'

    print_it_n_times(value,4)
</code></pre>
</section>

<section>
Introducing Optional
<pre><code class="hljs" data-trim contenteditable>
from typing import Union,Optional

DbValueType = Union[str,int,float]

OptionalDbValueType = Union[DbValueType,None]
# equivalent to
OptionalDbValueType = Optional[DbValueType]
</code></pre>
</section>

<section>
    Introducing Optional
<pre><code class="hljs" data-trim contenteditable>
from typing import List,Dict, Union,Optional

# make it DRY with an alias
DbValueType = Union[str,int,float]


database: Dict[int,DbValueType] = {
    1 : 'a' , 2 : 222222 , 3 : 'c' , 5 : 12.3 , 6: 'f'
}

def get_by_id(id:int)-> Optional[DbValueType]:
    if id in database:
        return database[id]
    return None

def print_it_n_times(s:DbValueType,n:int) -> None:
    print(s*n)

value = get_by_id(4)

reveal_type(value)
# Revealed type is 'Union[builtins.str, builtins.int, builtins.float, None]'

if value is not None:
    reveal_type(value)
    # Revealed type is 'Union[builtins.str, builtins.float]'

    print_it_n_times(value,4)

</code></pre>
</section>

<section>
    In Summary
    <ul>
       <li class="fragment">reveal_type tells us the type of a variable. Must be removed from final code</li>
       <li class="fragment">Union lets us specify a list of valid types</li>
       <li class="fragment">Types can be assigned to variables (called aliases)</li>
       <li class="fragment">Optional[T] == Union[T,None]</li>
    </ul>
</section>
</section>


<section>
    <section>
        <h3>Generics</h3>
        Sometimes types are determined when a function is envoked or a class is instantiated
    </section>

<section>
    Generic functions

    <pre><code class="hljs" data-trim contenteditable>
from typing import TypeVar, List
T1  = TypeVar('T1')
T2 = TypeVar('T2')

def cheese(input: List[T1]) -> T1:
    etc

# you can have multiple typevars

def spam(eggs:Dict[T1:T2],parrot:T1)-> T2:
    etc

    </code></pre>
</section>

<section>
    Generic functions

    <pre><code class="hljs" data-trim contenteditable>

from typing import TypeVar, Sequence, Optional

T = TypeVar('T')      # Declare type variable

def first(seq: Sequence[T]) -> T:
   return seq[0]

def last(seq: Sequence[T]) -> T:
   return seq[-1]


a = first([1,2,3])
reveal_type(a) # int

b = last([1,2,3])
reveal_type(b) # int

c = first(['a','b','c'])
reveal_type(c) # str

d = last(['a','b','c'])
reveal_type(d) # str

</code></pre>

</section>

<section>
    Generic classes
    <pre><code class="hljs" data-trim contenteditable>

from typing import TypeVar, List, Generic
T  = TypeVar('T')

class Stack(Generic[T]):
   def __init__(self) -> None:
       # Create an empty list with items of type T
       self.items: List[T] = []

   def push(self, item: T) -> None:
       self.items.append(item)

   def pop(self) -> T:
       return self.items.pop()

   def empty(self) -> bool:
       return not self.items


stack : Stack[int] = Stack()
# equivalent to
stack = Stack[int]()

stack.push(2)
stack.pop()
stack.push('x') #error

    </code></pre>
</section>


<section>
    Bind generics to specific types
    <pre><code class="hljs" data-trim contenteditable>

from typing import TypeVar, Generic

class Fruit:
    pass

class Apple(Fruit):
    pass

class RaceCar:
    pass

TFruit = TypeVar('TFruit',bound=Fruit)

class FruitTree(Generic[TFruit]):
    pass

x = FruitTree[Fruit]()
y = FruitTree[Apple]()
z = FruitTree[RaceCar]() # Error

    </code></pre>
</section>

<section>
    Excercise
<pre><code class="hljs" data-trim contenteditable>

class Queue:
    def __init__(self) -> None:
        self.items = []

    def push(self, item):
        self.items.append(item)

    def next(self):
        return self.items.pop(0)

    def peek(self):
        if self.items:
            return self.items[0]


int_queue = Queue()
int_queue.push(1)
int_queue.push("2") # should error

str_queue = Queue()
str_queue.push("1")
str_queue.push(2) # should error
</code></pre>
<a href="https://gitlab.com/sheena.oconnell/presentation-hello-python-typechecking/blob/master/excercises/generics.py" target="_blank">generics.py</a>

</section>
<section>
Answer
<pre><code class="hljs" data-trim contenteditable>
from typing import TypeVar, Generic, List, Optional

T = TypeVar('T')

class Queue(Generic[T]):
    def __init__(self) -> None:
        self.items: List[T] = []

    def push(self, item:T) -> None:
        self.items.append(item)

    def next(self) -> T:
        return self.items.pop(0)

    def peek(self) -> Optional[T]:
        if self.items:
            return self.items[0]
        return None


int_queue: Queue[int] = Queue()
int_queue.push(1)
int_queue.push("2") # Error: expected int

str_queue = Queue[str]()
str_queue.push("1")
str_queue.push(2) # Error: expected str
</code></pre>

</section>

<section>
    Excercise:

    Alter queue so that it only allows booleans, strings and integers
</section>

<section>
    Answer
<pre><code class="hljs" data-trim contenteditable>
from typing import TypeVar, Generic, List, Optional,Union

T = TypeVar('T',bound=Union[bool,str,int])

class Queue(Generic[T]):
    def __init__(self) -> None:
        self.items: List[T] = []

    def push(self, item:T) -> None:
        self.items.append(item)

    def next(self) -> T:
        return self.items.pop(0)

    def peek(self) -> Optional[T]:
        if self.items:
            return self.items[0]
        return None


int_queue: Queue[int] = Queue()
int_queue.push(1)
int_queue.push("2") # Error: expected int

str_queue = Queue[str]()
str_queue.push("1")
str_queue.push(2) # Error: expected str
</code></pre>
</section>

</section>

<section>

    <section>
<h3>Protocols</h3>
If it walks like a duck and quacks like a duck...
</section>
<section>

... it's a duck
<pre><code class="hljs" data-trim contenteditable>

class RubberDuck:
    def quack(self):
        return "squeak"

class MallardDuck:
    def quack(self):
        return "quack"

def all_the_quacks(all_the_ducks):
    for o in all_the_ducks:
        yield o.quack()


l = []
l.extend([RubberDuck() for _ in range(3)])
l.extend([MallardDuck() for _ in range(3)])

all_the_quacks(l)

</code></pre>

    </section>

<section>
add annotations...
<pre><code class="hljs" data-trim contenteditable>

from typing import TypeVar, List, Iterator
from typing_extensions import Protocol

class SupportsQuack(Protocol):
    def quack(self)-> str:
        ...

class RubberDuck:
    def quack(self) -> str:
        return "squeak"

class MallardDuck:
    def quack(self) -> str:
        return "quack"

def all_the_quacks(all_the_ducks:List[SupportsQuack]) -> Iterator[str]:
    for o in all_the_ducks:
        yield o.quack()

l: List[SupportsQuack] = []
l.extend([RubberDuck() for _ in range(3)])
l.extend([MallardDuck() for _ in range(3)])

all_the_quacks(l)

</code></pre>

</section>

<section>
    Excercise

    <pre><code class="hljs" data-trim contenteditable>

import random

class Foo:
    def is_valid(self):
        return random.choice([True,False])

class Bar:
    def is_valid(self):
        return random.choice([True,False])

def valid_instances(l):
    return [x for x in l if x.is_valid()]

l = []
l.extend([Foo() for _ in range(3)])
l.extend([Bar() for _ in range(3)])

valid = valid_instances(l)

    </code></pre>
    <a href="https://gitlab.com/sheena.oconnell/presentation-hello-python-typechecking/blob/master/excercises/protocols.py" target="_blank">protocols.py</a>

</section>

<section>
Answer
    <pre><code class="hljs" data-trim contenteditable>

import random
from typing import List
from typing_extensions import Protocol

class SupportsIsValid(Protocol):
    def is_valid(self) -> bool:
        ...

class Foo:
    def is_valid(self) -> bool:
        return random.choice([True,False])

class Bar:
    def is_valid(self) -> bool:
        return random.choice([True,False])

def valid_instances(l: List[SupportsIsValid]) -> List[SupportsIsValid]:
    return [x for x in l if x.is_valid()]

l: List[SupportsIsValid] = []
l.extend([Foo() for _ in range(3)])
l.extend([Bar() for _ in range(3)])

valid = valid_instances(l)
</code></pre>


</section>

</section>


<section>
    <section>
    <h3>Overloading</h3>

    Sometimes a functions can have different argument types in different situations...
</section>

<section>
    example
    <pre><code class="hljs" data-trim contenteditable>
import random
from typing import List
from typing_extensions import Protocol

class SupportsIsValid(Protocol):
    def is_valid(self) -> bool:
        ...

class Foo:
    def is_valid(self) -> bool:
        return random.choice([True,False])

class Bar:
    def is_valid(self) -> bool:
        return random.choice([True,False])

def valid_instances(
        l: List[SupportsIsValid],
        validator=None) -> List[SupportsIsValid]:
    if validator is not None:
        return [x for x in l if validator(x)]
    return [x for x in l if x.is_valid()]

l: List[SupportsIsValid] = []
l.extend([Foo() for _ in range(3)])
l.extend([Bar() for _ in range(3)])

valid = valid_instances(l)

    </code></pre>
</section>

<section>
    add annotations...
    <pre><code class="hljs" data-trim contenteditable>

import random
from typing import TypeVar, List, Callable,overload,Optional
from typing_extensions import Protocol


class SupportsIsValid(Protocol):
    def is_valid(self) -> bool:
        ...

class Foo:
    def is_valid(self) -> bool:
        return random.choice([True,False])

class Bar:
    def is_valid(self) -> bool:
        return random.choice([True,False])

T = TypeVar('T')

@overload
def valid_instances(l: List[T], validator: Callable[[T],bool]) -> List[T]:
    ...

@overload
def valid_instances(l: List[SupportsIsValid])-> List[SupportsIsValid]:
    ...

def valid_instances( l:List[T], validator:Optional[Callable[[T],bool]]=None ) -> List[T]:
    if validator is not None:
        return [x for x in l if validator(x)]
    return [x for x in l if x.is_valid()]


l: List[SupportsIsValid] = []
l.extend([Foo() for _ in range(3)])
l.extend([Bar() for _ in range(3)])

valid = valid_instances(l)

</code></pre>
</section>

<section>
    Excercise
    <pre><code class="hljs" data-trim contenteditable>
from typing import Union, Optional

class Event:
    def __init__(self,*args):
        pass
class ClickEvent(Event): pass
class DragEvent(Event): pass

def mouse_event(x1: int,
                y1: int,
                x2: Optional[int] = None,
                y2: Optional[int] = None) -> Union[ClickEvent, DragEvent]:
    if x2 is None and y2 is None:
        return ClickEvent(x1, y1)
    elif x2 is not None and y2 is not None:
        return DragEvent(x1, y1, x2, y2)
    else:
        raise TypeError("Bad arguments")

reveal_type(mouse_event(1,2))     # Union[ClickEvent, DragEvent]
reveal_type(mouse_event(1,2,3))   # Union[ClickEvent, DragEvent]
reveal_type(mouse_event(1,2,3,4)) # Union[ClickEvent, DragEvent]

    </code></pre>
    <a href="https://gitlab.com/sheena.oconnell/presentation-hello-python-typechecking/blob/master/excercises/overload.py" target="_blank">overload.py</a>

</section>

<section>
    Answer
    <pre><code class="hljs" data-trim contenteditable>
from typing import Union, Optional, overload

class Event:
    def __init__(self,*args):
        pass
class ClickEvent(Event): pass
class DragEvent(Event): pass

@overload
def mouse_event(x1: int, y1: int) -> ClickEvent:
    ...

@overload
def mouse_event(x1: int, y1: int, x2: int, y2: int) -> DragEvent:
    ...

def mouse_event(x1: int,
                y1: int,
                x2: Optional[int] = None,
                y2: Optional[int] = None) -> Union[ClickEvent, DragEvent]:
    if x2 is None and y2 is None:
        return ClickEvent(x1, y1)
    elif x2 is not None and y2 is not None:
        return DragEvent(x1, y1, x2, y2)
    else:
        raise TypeError("Bad arguments")


reveal_type(mouse_event(1,2))     # ClickEvent
reveal_type(mouse_event(1,2,3))   # No overload varient match
reveal_type(mouse_event(1,2,3,4)) # DragEvent

    </code></pre>
</section>

</section>

<section>
    <section>
        <h2>Where to from here?</h2> <!-- ok -->
    </section>
    <section>
        <h3>Adding types to exiting code base</h3>

        <ul>
            <li>

        <a href="https://mypy.readthedocs.io/en/latest/existing_code.html" target="_blank">https://mypy.readthedocs.io/en/latest/existing_code.html</a>
            </li>
            <li>

        <a href="https://github.com/Instagram/MonkeyType" target="_blank">MonkeyType</a>
            </li>
            <li>
        <a href="https://github.com/dropbox/pyannotate" target="_blank">PyAnnotate</a>

            </li>
        </ul>

    </section>
    <section>
        <h3>Oh Crap</h3>
        <a href="https://mypy.readthedocs.io/en/stable/common_issues.html" target="_blank">Common issues</a>
    </section>
    <section>
        <h3>Mypy workflows</h3>
        <ul>
            <li>
                Editor intgraion
                <ul>
                    <li>Vim: <a href="https://github.com/Integralist/vim-mypy" target="_blank">vim-mypy</a></li>
                    <li>Emacs: using <a href="http://www.flycheck.org/en/latest/" target="_blank">Flycheck</a> and <a href="https://github.com/lbolla/emacs-flycheck-mypy" target="_blank">Flycheck-mypy</a></li>
                    <li>Sublime Text: <a href="https://github.com/fredcallaway/SublimeLinter-contrib-mypy" target="_blank">SublimeLinter-contrib-mypy</a></li>
                    <li>Atom: <a href="https://atom.io/packages/linter-mypy" target="_blank">linter-mypy</a></li>
                    <li>PyCharm: <a href="https://github.com/dropbox/mypy-PyCharm-plugin" target="_blank">mypy plugin </a>(PyCharm integrates its own implementation of PEP 484)</li>
                    <li>VS Code: provides <a href="https://code.visualstudio.com/docs/python/linting#_specific-linters" target="_blank">basic integration</a> with mypy.</li>

                </ul>
            </li>
            <li>
        <a href="https://pypi.org/project/pytest-mypy/" target="_blank">Pytest intgration</a>
            </li>
            <li>
        <a href="https://mypy.readthedocs.io/en/stable/config_file.html" target="_blank">Command line configuration</a>
            </li>

    </section>

    <section>
        <h3>Runtime type checking</h3>
        <ul>
            <li><a href="https://github.com/agronholm/typeguard" target="_blank">TypeGuard</a></li>
            <li><a href="https://github.com/RussBaz/enforce" target="_blank">Enforce</a></li>
            <li><a href="https://github.com/Instagram/MonkeyType" target="_blank">MonkeyType</a></li>
        </ul>
    </section>


</section>

    <section>
        <h1>THE END</h1>
    </section>


			</div>
		</div>

		<script src="lib/js/head.min.js"></script>
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/highlight/highlight.js', async: true, callback: function() { hljs.initHighlightingOnLoad(); } }
				]
			});
		</script>
	</body>
</html>
